#include "hmg.ch"

/*
* Level p101
*/
FUNCTION p101_Main
PUBLIC oPrint := L3WPrint():New()
Set Date Italian
Set Century On
DBUSEAREA( .T., "DBFNTX", "Test.dbf", "TEST" )
IF !FILE( "testname.NTX" )
* Create order by first field plus last field.
* You can't search by this order. Only for test.
 TEST->( ordCreate( "testname.NTX",                     ;
                    "First Name",                       ;
                    "TEST->First + TEST->Last",       ;
                    {|| TEST->First  + TEST->Last } ) )
ENDIF
IF !FILE( "testprov.NTX" )
* Create order by first field plus last field.
* You can't search by this order. Only for test.
 TEST->( ordCreate( "testprov.NTX",                     ;
                    "Province",                       ;
                    "TEST->Province",       ;
                    {|| TEST->Province } ) )
ENDIF
TEST->( ordListAdd( "testname.NTX", "First Name" ) )
TEST->( ordListAdd( "testprov.NTX", "Province" ) )
TEST->( ordSetFocus( 1 ) )

IF oPrint:Error()
 MsgStop(oPrint:ErrorMsg())
ELSE
 IF oPrint:Select()
  oPrint:Setpro("margin", {5, 5, 5, 5})
  oPrint:Setpro("repoheader", { {|| p101_rphd()}, 0, 10 } )
  oPrint:Setpro("pageheader", { {|| p101_pghd()}, 0, 20 } )
  oPrint:Setpro("bodyheader", { {|| p101_bdhd()}, 0, 20 } )
  oPrint:Setpro("bodyfooter", { {|| p101_bdfo()}, 0, 10 } )
  oPrint:Setpro("pagefooter", { {|| p101_pgfo()}, 270, 20 } )
  oPrint:Setpro("repofooter", { {|| p101_rpfo()}, 280, 5} )
  p101_DoPrint()
 ENDIF
ENDIF
DBCLOSEALL()
RETURN NIL
/*
* Level p101 subfuction
*/
STATIC FUNCTION p101_DoPrint()
LOCAL nCol := INT( (oPrint:Getpro("maxcol") - 11) /2 )
LOCAL nCounter := 0
oPrint:StartDoc()
TEST->(DBGOTOP())
DO WHILE !TEST->(EOF())
 oPrint:Setpro("rowheight", 6)
 oPrint:PrintText( .F., TEST->Code, 0, 2, 10, 6, "Helvetica", 9, .F., .F., .F., .F., , "LEFT" )
 oPrint:PrintText( .F., TEST->First, 0, 30, 60, 6, "Helvetica", 9, .F., .F., .F., .F., , "LEFT" )
 oPrint:PrintText( .F., TEST->Last, 0, 70, 60, 6, "Helvetica", 9, .F., .F., .F., .F., , "LEFT" )
 oPrint:PrintText( .F., DTOC(TEST->Birth), 0, 175, 60, 6, "Helvetica", 9, .F., .F., .F., .F., , "LEFT" )
 oPrint:SkipLine(oPrint:Getpro("rowheight"))
 TEST->(DBSKIP(+1))
ENDDO
oPrint:EndDoc()
RETURN NIL

/*
* Level p101 Body Header
*/
STATIC FUNCTION p101_BdHd()
LOCAL aColor := {0, 0, 0}
LOCAL nMinCol := oPrint:Getpro("mincol"), nMaxCol:= oPrint:Getpro("maxcol"), nRow := 0
oPrint:Setpro("rowheight",7)
oPrint:PrintText( .F., "BODY Header row 1 ", , , 200, 6, , , .T., .F., .F., .F., aColor, "CENTER" )
oPrint:SkipLine(oPrint:Getpro("rowheight"))
oPrint:PrintText( .F., "BODY Header row 2 ", , , 200, 6, , , .T., .F., .F., .F., aColor, "CENTER" )
oPrint:SkipLine(oPrint:Getpro("rowheight"))
nRow := oPrint:Getpro("currow")
oPrint:PrintLine( .T., nRow, nMinCol, nRow, nMaxCol, 0.1, aColor )
RETURN NIL

/*
* Level p101 Body Footer
*/
STATIC FUNCTION p101_BdFo()
LOCAL aColor := {0, 0, 0}
LOCAL nMinCol := oPrint:Getpro("mincol"), nMaxCol:= oPrint:Getpro("maxcol")
oPrint:Setpro("rowheight",7)
oPrint:PrintText( .F., "BODY Footer row 1 ", , , 200, 6, , , .T., .F., .F., .F., aColor, "CENTER" )
RETURN NIL


/*
* Level p101 Page Header
*/
STATIC FUNCTION p101_PgHd()
LOCAL aColor := {0, 255, 0}
LOCAL nMinCol := oPrint:Getpro("mincol"), nMaxCol:= oPrint:Getpro("maxcol")
oPrint:PrintRectangle( .F., 0, nMinCol, 20, nMaxCol, 0.1, aColor )
oPrint:Setpro("rowheight",7)
oPrint:PrintText( .F., "PAGE Header row 1 ", , , 200, 6, , , .T., .F., .F., .F., aColor, "CENTER" )
oPrint:SkipLine(oPrint:Getpro("rowheight"))
oPrint:PrintText( .F., "PAGE Header row 2 ", , , 200, 6, , , .T., .F., .F., .F., aColor, "CENTER" )
RETURN NIL

/*
* Level p101 Page Footer
*/
STATIC FUNCTION p101_PgFo()
LOCAL aColor := {0, 255, 0}, cPageNum := LTRIM( STR(oPrint:Getpro("pagenum")) )
LOCAL nMinCol := oPrint:Getpro("mincol"), nMaxCol:= oPrint:Getpro("maxcol")
oPrint:PrintLine( .F., 0, nMinCol, 0, nMaxCol, 0.1, aColor )
oPrint:Setpro("rowheight",7)
oPrint:PrintText( .F., "PAGE Footer 1 Pag. "+cPageNum, , , 200, 6, , , .T., .F., .F., .F., aColor, "CENTER" )
RETURN NIL

/*
* Level p101 Header
*/
STATIC FUNCTION p101_RpHd()
LOCAL aColor := {255, 0, 0}
LOCAL nMinCol := oPrint:Getpro("mincol"), nMaxCol:= oPrint:Getpro("maxcol")
LOCAL nRow := 0
oPrint:Setpro("rowheight",7)
oPrint:PrintText( .F., "REPORT Header 1 ", , , 200, 6, , , .T., .F., .F., .F., aColor, "CENTER" )
nRow := oPrint:Getpro("currow")
oPrint:PrintLine( .T., nRow, nMinCol, nRow, nMaxCol, 0.1, aColor )
RETURN NIL

/*
* Report Footer
*/
STATIC FUNCTION p101_RpFo()
LOCAL aColor := {255, 0, 0}
LOCAL nMinCol := oPrint:Getpro("mincol"), nMaxCol:= oPrint:Getpro("maxcol")
LOCAL nRow := oPrint:Getpro("currow")
oPrint:PrintLine( .T., nRow, nMinCol, nRow, nMaxCol, 0.4, aColor )
RETURN NIL
