#include "hmg.ch"

/*
* Level p102
*/
FUNCTION p102_Main
PUBLIC oPrint := L3WPrint():New()
Set Date Italian
Set Century On
DBUSEAREA( .T., "DBFNTX", "Test.dbf", "TEST" )
IF !FILE( "testname.NTX" )
* Create order by first field plus last field.
* You can't search by this order. Only for test.
 TEST->( ordCreate( "testname.NTX",                     ;
                    "First Name",                       ;
                    "TEST->First + TEST->Last",       ;
                    {|| TEST->First  + TEST->Last } ) )
ENDIF
IF !FILE( "testprov.NTX" )
* Create order by first field plus last field.
* You can't search by this order. Only for test.
 TEST->( ordCreate( "testprov.NTX",                     ;
                    "Province",                       ;
                    "TEST->Province",       ;
                    {|| TEST->Province } ) )
ENDIF
TEST->( ordListAdd( "testname.NTX", "First Name" ) )
TEST->( ordListAdd( "testprov.NTX", "Province" ) )
TEST->( ordSetFocus( 1 ) )

IF oPrint:Error()
 MsgStop(oPrint:ErrorMsg())
ELSE
 IF oPrint:Select()
  oPrint:Setpro("margin", {5, 5, 5, 5})
  oPrint:Setpro("repoheader", { {|| p102_rphd()}, 0, 10 } )
  oPrint:Setpro("pageheader", { {|| p102_pghd()}, 0, 20 } )
  oPrint:Setpro("bodyheader", { {|| p102_bdhd()}, 0, 20 } )
  oPrint:Setpro("bodyfooter", { {|| p102_bdfo()}, 0, 10 } )
  oPrint:Setpro("pagefooter", { {|| p102_pgfo()}, 270, 20 } )
  oPrint:Setpro("repofooter", { {|| p102_rpfo()}, 280, 5} )
  p102_DoPrint()
 ENDIF
ENDIF
DBCLOSEALL()
RETURN NIL
/*
* Level p102 subfuction
*/
STATIC FUNCTION p102_DoPrint()
LOCAL nCol := INT( (oPrint:Getpro("maxcol") - 11) /2 )
LOCAL nCounter := 0, cLastProv := ""
PRIVATE nTotal := 0
oPrint:StartDoc()
TEST->( ordSetFocus( 2 ) )
TEST->(DBGOTOP())
cLastProv := TEST->Province
DO WHILE !TEST->(EOF())
 IF cLastProv != TEST->Province
  p102_Grouped(cLastProv, nCounter)
  cLastProv := TEST->Province
  nCounter := 0
 ENDIF
 nTotal += 1
 nCounter += 1
 TEST->(DBSKIP(+1))
ENDDO
p102_Grouped(cLastProv, nCounter)
oPrint:EndDoc()
RETURN NIL
/*
* Level p102 subfuction
*/
STATIC FUNCTION p102_Grouped(cLastProv, nCounter)
oPrint:Setpro("rowheight", 6)
oPrint:PrintText( .F., "In province ", 0, 2, 40, 6, "Helvetica", 9, .F., .F., .F., .F., , "LEFT" )
oPrint:PrintText( .F., cLastProv, 0, 45, 60, 6, "Helvetica", 9, .F., .F., .F., .F., , "LEFT" )
oPrint:PrintText( .F., "there are ", 0, 65, 40, 6, "Helvetica", 9, .F., .F., .F., .F., , "LEFT" )
oPrint:PrintText( .F., Hb_ValToExp(nCounter), 0, 110, 60, 6, "Helvetica", 9, .F., .F., .F., .F., , "LEFT" )
oPrint:SkipLine(oPrint:Getpro("rowheight"))
RETURN NIL

/*
* Level p102 Body Header
*/
STATIC FUNCTION p102_BdHd()
LOCAL aColor := {0, 0, 0}
LOCAL nMinCol := oPrint:Getpro("mincol"), nMaxCol:= oPrint:Getpro("maxcol"), nRow := 0
oPrint:Setpro("rowheight",7)
oPrint:PrintText( .F., "BODY Header row 1 ", , , 200, 6, , , .T., .F., .F., .F., aColor, "CENTER" )
oPrint:SkipLine(oPrint:Getpro("rowheight",7))
oPrint:PrintText( .F., "BODY Header row 2 ", , , 200, 6, , , .T., .F., .F., .F., aColor, "CENTER" )
oPrint:SkipLine(oPrint:Getpro("rowheight",7))
nRow := oPrint:Getpro("currow")
oPrint:PrintLine( .T., nRow, nMinCol, nRow, nMaxCol, 0.1, aColor )
RETURN NIL

/*
* Level p102 Body Footer
*/
STATIC FUNCTION p102_BdFo()
LOCAL aColor := {0, 0, 0}
LOCAL nMinCol := oPrint:Getpro("mincol"), nMaxCol:= oPrint:Getpro("maxcol")
oPrint:Setpro("rowheight",7)
oPrint:PrintText( .F., "BODY Footer row 1 ", , , 200, 6, , , .T., .F., .F., .F., aColor, "CENTER" )
oPrint:SkipLine(oPrint:Getpro("rowheight"))
oPrint:PrintText( .F., "I've read ", 0, 65, 40, 6, "Helvetica", 9, .F., .F., .F., .F., , "LEFT" )
oPrint:PrintText( .F., Hb_ValToExp(nTotal), 0, 110, 60, 6, "Helvetica", 9, .F., .F., .F., .F., , "LEFT" )
RETURN NIL


/*
* Level p102 Page Header
*/
STATIC FUNCTION p102_PgHd()
LOCAL aColor := {0, 255, 0}
LOCAL nMinCol := oPrint:Getpro("mincol"), nMaxCol:= oPrint:Getpro("maxcol")
oPrint:PrintRectangle( .F., 0, nMinCol, 20, nMaxCol, 0.1, aColor )
oPrint:Setpro("rowheight",7)
oPrint:PrintImage(.F., 'Images/hmg.jpg', +3, nMinCol+5, 15, 15, .F.)
oPrint:PrintText( .F., "PAGE Header row 1 ", , , 200, 6, , , .T., .F., .F., .F., aColor, "CENTER" )
oPrint:SkipLine(oPrint:Getpro("rowheight"))
oPrint:Setpro("rowheight",7)
oPrint:PrintText( .F., "PAGE Header row 2 ", , , 200, 6, , , .T., .F., .F., .F., aColor, "CENTER" )
RETURN NIL

/*
* Level p102 Page Footer
*/
STATIC FUNCTION p102_PgFo()
LOCAL aColor := {0, 255, 0}, cPageNum := LTRIM( STR(oPrint:Getpro("pagenum")) )
LOCAL nMinCol := oPrint:Getpro("mincol"), nMaxCol:= oPrint:Getpro("maxcol")
oPrint:PrintLine( .F., 0, nMinCol, 0, nMaxCol, 0.1, aColor )
oPrint:Setpro("rowheight",7)
oPrint:PrintText( .F., "PAGE Footer 1 Pag. "+cPageNum, , , 200, 6, , , .T., .F., .F., .F., aColor, "CENTER" )
RETURN NIL

/*
* Level p102 Header
*/
STATIC FUNCTION p102_RpHd()
LOCAL aColor := {255, 0, 0}
LOCAL nMinCol := oPrint:Getpro("mincol"), nMaxCol:= oPrint:Getpro("maxcol")
LOCAL nRow := 0
oPrint:Setpro("rowheight",7)
oPrint:PrintText( .F., "REPORT Header 1 ", , , 200, 6, , , .T., .F., .F., .F., aColor, "CENTER" )
nRow := oPrint:Getpro("currow")
oPrint:PrintLine( .T., nRow, nMinCol, nRow, nMaxCol, 0.1, aColor )
RETURN NIL

/*
* Report Footer
*/
STATIC FUNCTION p102_RpFo()
LOCAL aColor := {255, 0, 0}
LOCAL nMinCol := oPrint:Getpro("mincol"), nMaxCol:= oPrint:Getpro("maxcol")
LOCAL nRow := oPrint:Getpro("currow")
oPrint:PrintLine( .T., nRow, nMinCol, nRow, nMaxCol, 0.4, aColor )
RETURN NIL
